Create Canary Deploy
Endpoint to create a canary deploy configuration for an assistant.
Creates a new canary deploy configuration with multiple version IDs and their traffic percentages for A/B testing or gradual rollouts of assistant versions.
import Telnyx from 'telnyx';
const client = new Telnyx({
apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
});
const canaryDeployResponse = await client.ai.assistants.canaryDeploys.create('assistant_id');
console.log(canaryDeployResponse.assistant_id);import os
from telnyx import Telnyx
client = Telnyx(
api_key=os.environ.get("TELNYX_API_KEY"), # This is the default and can be omitted
)
canary_deploy_response = client.ai.assistants.canary_deploys.create(
assistant_id="assistant_id",
)
print(canary_deploy_response.assistant_id)
package main
import (
"context"
"fmt"
"github.com/team-telnyx/telnyx-go"
"github.com/team-telnyx/telnyx-go/option"
)
func main() {
client := telnyx.NewClient(
option.WithAPIKey("My API Key"),
)
canaryDeployResponse, err := client.AI.Assistants.CanaryDeploys.New(
context.TODO(),
"assistant_id",
telnyx.AIAssistantCanaryDeployNewParams{
CanaryDeploy: telnyx.CanaryDeployParam{},
},
)
if err != nil {
panic(err.Error())
}
fmt.Printf("%+v\n", canaryDeployResponse.AssistantID)
}
package com.telnyx.sdk.example;
import com.telnyx.sdk.client.TelnyxClient;
import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;
import com.telnyx.sdk.models.ai.assistants.canarydeploys.CanaryDeploy;
import com.telnyx.sdk.models.ai.assistants.canarydeploys.CanaryDeployCreateParams;
import com.telnyx.sdk.models.ai.assistants.canarydeploys.CanaryDeployResponse;
public final class Main {
private Main() {}
public static void main(String[] args) {
TelnyxClient client = TelnyxOkHttpClient.fromEnv();
CanaryDeployCreateParams params = CanaryDeployCreateParams.builder()
.assistantId("assistant_id")
.canaryDeploy(CanaryDeploy.builder().build())
.build();
CanaryDeployResponse canaryDeployResponse = client.ai().assistants().canaryDeploys().create(params);
}
}require "telnyx"
telnyx = Telnyx::Client.new(api_key: "My API Key")
canary_deploy_response = telnyx.ai.assistants.canary_deploys.create("assistant_id")
puts(canary_deploy_response)<?php
require_once dirname(__DIR__) . '/vendor/autoload.php';
use Telnyx\Client;
use Telnyx\Core\Exceptions\APIException;
$client = new Client(apiKey: getenv('TELNYX_API_KEY') ?: 'My API Key');
try {
$canaryDeployResponse = $client->ai->assistants->canaryDeploys->create(
'assistant_id',
rules: [
[
'serve' => [
'rollout' => [['versionID' => 'version_id', 'weight' => 0]],
'versionID' => 'version_id',
],
'match' => [
[
'attribute' => 'attribute',
'operator' => 'in',
'values' => ['string'],
],
],
],
],
);
var_dump($canaryDeployResponse);
} catch (APIException $e) {
echo $e->getMessage();
}telnyx ai:assistants:canary-deploys create \
--api-key 'My API Key' \
--assistant-id assistant_idcurl --request POST \
--url https://api.telnyx.com/v2/ai/assistants/{assistant_id}/canary-deploys \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"rules": [
{
"match": [
{
"attribute": "Attribute",
"operator": "in",
"values": [
"string"
]
}
],
"serve": {
"version_id": "Version Id",
"rollout": [
{
"version_id": "Version Id",
"weight": 0
}
]
}
}
]
}
'{
"assistant_id": "Assistant Id",
"rules": [
{
"match": [
{
"attribute": "Attribute",
"operator": "in",
"values": [
"string"
]
}
],
"serve": {
"version_id": "Version Id",
"rollout": [
{
"version_id": "Version Id",
"weight": 0
}
]
}
}
],
"created_at": "2024-01-23T18:10:02.574Z",
"updated_at": "2024-01-23T18:10:02.574Z"
}{
"errors": [
{
"code": "10007",
"title": "<string>",
"detail": "<string>",
"source": {
"pointer": "<string>"
}
}
]
}{
"errors": [
{
"code": "10036",
"title": "Resource is being processed",
"detail": "A request with this Idempotency-Key is already being processed.",
"source": {
"pointer": "/header/Idempotency-Key"
}
}
]
}{
"errors": [
{
"code": "10007",
"title": "<string>",
"detail": "<string>",
"source": {
"pointer": "<string>"
}
}
]
}{
"detail": [
{
"loc": [
"body",
"name"
],
"msg": "Field required",
"type": "missing"
}
]
}{
"errors": [
{
"code": "10007",
"title": "<string>",
"detail": "<string>",
"source": {
"pointer": "<string>"
}
}
]
}Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
Headers
Optional opaque, unquoted key for safely retrying the same logical request. Keys must contain 1 to 255 letters, numbers, hyphens, or underscores. Generate a unique UUID v4 for each operation and reuse it only when retrying that operation with the same request. Invalid headers—including duplicate, empty, malformed, or overlong values—return 400 with error code 10015. A request already in progress with the same key returns 409; reusing the key with a different request returns 422. Only successful responses are replayed, for up to 24 hours. Do not include sensitive data in the key.
1 - 255^[A-Za-z0-9_-]{1,255}$Path Parameters
Unique identifier of the assistant.
Body
Create/update request body. Accepts:
rules— canonical ordered list of routing rules
Show child attributes
Show child attributes
Was this page helpful?
import Telnyx from 'telnyx';
const client = new Telnyx({
apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
});
const canaryDeployResponse = await client.ai.assistants.canaryDeploys.create('assistant_id');
console.log(canaryDeployResponse.assistant_id);import os
from telnyx import Telnyx
client = Telnyx(
api_key=os.environ.get("TELNYX_API_KEY"), # This is the default and can be omitted
)
canary_deploy_response = client.ai.assistants.canary_deploys.create(
assistant_id="assistant_id",
)
print(canary_deploy_response.assistant_id)
package main
import (
"context"
"fmt"
"github.com/team-telnyx/telnyx-go"
"github.com/team-telnyx/telnyx-go/option"
)
func main() {
client := telnyx.NewClient(
option.WithAPIKey("My API Key"),
)
canaryDeployResponse, err := client.AI.Assistants.CanaryDeploys.New(
context.TODO(),
"assistant_id",
telnyx.AIAssistantCanaryDeployNewParams{
CanaryDeploy: telnyx.CanaryDeployParam{},
},
)
if err != nil {
panic(err.Error())
}
fmt.Printf("%+v\n", canaryDeployResponse.AssistantID)
}
package com.telnyx.sdk.example;
import com.telnyx.sdk.client.TelnyxClient;
import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;
import com.telnyx.sdk.models.ai.assistants.canarydeploys.CanaryDeploy;
import com.telnyx.sdk.models.ai.assistants.canarydeploys.CanaryDeployCreateParams;
import com.telnyx.sdk.models.ai.assistants.canarydeploys.CanaryDeployResponse;
public final class Main {
private Main() {}
public static void main(String[] args) {
TelnyxClient client = TelnyxOkHttpClient.fromEnv();
CanaryDeployCreateParams params = CanaryDeployCreateParams.builder()
.assistantId("assistant_id")
.canaryDeploy(CanaryDeploy.builder().build())
.build();
CanaryDeployResponse canaryDeployResponse = client.ai().assistants().canaryDeploys().create(params);
}
}require "telnyx"
telnyx = Telnyx::Client.new(api_key: "My API Key")
canary_deploy_response = telnyx.ai.assistants.canary_deploys.create("assistant_id")
puts(canary_deploy_response)<?php
require_once dirname(__DIR__) . '/vendor/autoload.php';
use Telnyx\Client;
use Telnyx\Core\Exceptions\APIException;
$client = new Client(apiKey: getenv('TELNYX_API_KEY') ?: 'My API Key');
try {
$canaryDeployResponse = $client->ai->assistants->canaryDeploys->create(
'assistant_id',
rules: [
[
'serve' => [
'rollout' => [['versionID' => 'version_id', 'weight' => 0]],
'versionID' => 'version_id',
],
'match' => [
[
'attribute' => 'attribute',
'operator' => 'in',
'values' => ['string'],
],
],
],
],
);
var_dump($canaryDeployResponse);
} catch (APIException $e) {
echo $e->getMessage();
}telnyx ai:assistants:canary-deploys create \
--api-key 'My API Key' \
--assistant-id assistant_idcurl --request POST \
--url https://api.telnyx.com/v2/ai/assistants/{assistant_id}/canary-deploys \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"rules": [
{
"match": [
{
"attribute": "Attribute",
"operator": "in",
"values": [
"string"
]
}
],
"serve": {
"version_id": "Version Id",
"rollout": [
{
"version_id": "Version Id",
"weight": 0
}
]
}
}
]
}
'{
"assistant_id": "Assistant Id",
"rules": [
{
"match": [
{
"attribute": "Attribute",
"operator": "in",
"values": [
"string"
]
}
],
"serve": {
"version_id": "Version Id",
"rollout": [
{
"version_id": "Version Id",
"weight": 0
}
]
}
}
],
"created_at": "2024-01-23T18:10:02.574Z",
"updated_at": "2024-01-23T18:10:02.574Z"
}{
"errors": [
{
"code": "10007",
"title": "<string>",
"detail": "<string>",
"source": {
"pointer": "<string>"
}
}
]
}{
"errors": [
{
"code": "10036",
"title": "Resource is being processed",
"detail": "A request with this Idempotency-Key is already being processed.",
"source": {
"pointer": "/header/Idempotency-Key"
}
}
]
}{
"errors": [
{
"code": "10007",
"title": "<string>",
"detail": "<string>",
"source": {
"pointer": "<string>"
}
}
]
}{
"detail": [
{
"loc": [
"body",
"name"
],
"msg": "Field required",
"type": "missing"
}
]
}{
"errors": [
{
"code": "10007",
"title": "<string>",
"detail": "<string>",
"source": {
"pointer": "<string>"
}
}
]
}